#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.Design;
#endregion
//This Indicator has been ported from
//Volume Price Analysis AFL - VPA Version 1.0
//AFL by Karthikmarar. Detailed explanation available at www.vpanalysis.blogspot.com
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Volume Spread Analysis
    /// </summary>
    [Description("Volume Spread Analysis")]
    public class VPA1 : Indicator
    {
        #region Variables
        // Wizard generated variables
            private int volumeEmaAve = 30; // Default setting for VolumeEmaAve
		
			private double avgRange = 0;
			private double avgVolume = 0;
			private double dwHighClose = 0.70;
			private double dwLowClose = 0.25;
		
			private double dwUltraHighVol = 2;
			private double dwVeryHighVol = 2.2;
			private double dwHighVol = 1.8;
			private double dwAboveAvgVol = 1.5;
			private double dwLowVol = 0.8;
		
		
			private double VolSD ; 
			private double Cloc;
			private double x;
			private double x1;
			private double TLL;
			private double TLM;
			private double TLS;
			private double mp;
		
			private double nbf=0.7;
			private double wbf = 1.5;
		
			
			private BoolSeries utbar ;
			private BoolSeries utcond1 ;
			private BoolSeries utcond2 ;
			private BoolSeries utcond3 ;
			private BoolSeries trbar ;
			private BoolSeries Hutbar ;
			private BoolSeries Hutcond;
			private BoolSeries tcbar ;
			private BoolSeries Scond1 ;
			private BoolSeries Scond2 ;
			private BoolSeries scond;
			private BoolSeries stdn0 ;
			private BoolSeries stdn ;
			private BoolSeries stdn1 ;
			private BoolSeries stdn2 ;
			private BoolSeries bycond1;
			private BoolSeries bycond ;
			private BoolSeries stvol ;
			private BoolSeries ndbar ;
			private BoolSeries nsbar;
			private BoolSeries nbbar;
			private BoolSeries nbbar1;
			private BoolSeries lvtbar;
			private BoolSeries lvtbar1;
			private BoolSeries lvtbar2;
			private BoolSeries dbar;
			private BoolSeries eftup ;
			private BoolSeries eftupfl;
			private BoolSeries eftdn;
			private BoolSeries upbar;
			private BoolSeries dnbar;
			private BoolSeries wrb;
			private BoolSeries nrb; 
			private BoolSeries Vl;
			private BoolSeries Vh;
			private BoolSeries Vb;
			private BoolSeries ucls;
			private BoolSeries mcls;
			private BoolSeries Vlcls;
			private BoolSeries Vhcls;
			private BoolSeries dcls;
		

			private bool banners = true;
			private bool alertss = false;
			
			private string bannerstring;
			private string titlestring;
		
			private DataSeries spread;
			private DataSeries Vrg;	//Volume moving average
			private DataSeries Vp3;	// +3 Volume SD
			private DataSeries Vp2;	// +2 Volume SD
			private DataSeries Vp1;	// +1 Volume SD
			private DataSeries Vn1;	// -1 Volume SD
			private DataSeries Vn2;	// -2 Volume SD
			private DataSeries Vn3;	// -3 Volume SD
			private DataSeries arg;	//Wilders average of Range
			private DataSeries j;	// SMA(C,5)
		
			private Font font = new Font ("Arial", 6, FontStyle.Bold);
			private Color bandAreaColor = Color.Silver;
			private Color bannerColor = Color.White;
			private Color textColor = Color.White;
			private int bandAreaColorOpacity = 8;
		
        // User defined variables (add any user defined variables below)
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            Add(new Plot(new Pen(Color.FromKnownColor(KnownColor.Blue), 2), PlotStyle.Line, "VolumeEma"));
            Add(new Plot(new Pen(Color.FromKnownColor(KnownColor.LimeGreen), 5), PlotStyle.Bar, "Strong"));
			Add(new Plot(new Pen(Color.FromKnownColor(KnownColor.Red), 5), PlotStyle.Bar, "Weak"));
			Add(new Plot(new Pen(Color.FromKnownColor(KnownColor.Yellow), 5), PlotStyle.Bar, "Strong-Weak"));
			
			CalculateOnBarClose	= true;
            Overlay				= false;
            PriceTypeSupported	= false;
			
			spread 		= new DataSeries(this);
			Vrg 		= new DataSeries(this);
			Vp3 = new DataSeries(this);
			Vp2 = new DataSeries(this);
			Vp1 = new DataSeries(this);
			Vn1 = new DataSeries(this);
			Vn2 = new DataSeries(this);
			Vn3 = new DataSeries(this);
			arg = new DataSeries(this);
			j = new DataSeries(this);
			
			utbar  		= new BoolSeries(this);
			utcond1  	= new BoolSeries(this);
			utcond2 	= new BoolSeries(this) ;
			utcond3  	= new BoolSeries(this);
			trbar 		= new BoolSeries(this);
			Hutbar  	= new BoolSeries(this);
			Hutcond 	= new BoolSeries(this);
			tcbar  		= new BoolSeries(this);
			Scond1  	= new BoolSeries(this);
			Scond2  	= new BoolSeries(this);
			scond 		= new BoolSeries(this);
			stdn0  		= new BoolSeries(this);
			stdn  		= new BoolSeries(this);
			stdn1 		= new BoolSeries(this);
			stdn2  		= new BoolSeries(this);
			bycond1 	= new BoolSeries(this);
			bycond  	= new BoolSeries(this);
			stvol 		= new BoolSeries(this);
			ndbar  		= new BoolSeries(this);
			nsbar 		= new BoolSeries(this);
			nbbar 		= new BoolSeries(this);
			nbbar1 		= new BoolSeries(this);
			lvtbar 		= new BoolSeries(this);
			lvtbar1 	= new BoolSeries(this);
			lvtbar2 	= new BoolSeries(this);
			dbar 		= new BoolSeries(this);
			eftup  		= new BoolSeries(this);
			eftupfl 	= new BoolSeries(this);
			eftdn 		= new BoolSeries(this);
			upbar 		= new BoolSeries(this);
			dnbar 		= new BoolSeries(this);
			wrb 		= new BoolSeries(this);
			nrb 		= new BoolSeries(this); 
			Vl 			= new BoolSeries(this);
			Vh 			= new BoolSeries(this);
			Vb 			= new BoolSeries(this);
			ucls 		= new BoolSeries(this);
			mcls 		= new BoolSeries(this);
			Vlcls 		= new BoolSeries(this);
			Vhcls 		= new BoolSeries(this);
			dcls 		= new BoolSeries(this);
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {

			
			if (CurrentBar< volumeEmaAve) return;
			
			spread.Set(High[0] - Low[0]);
			avgVolume = EMA(EMA(Volume, volumeEmaAve),1)[0] ;
			VolumeEma.Set(avgVolume);	
			avgRange = SMA(spread,30)[0];
				
//			Calculate Volume moving average and it's standard deviation
			Vrg.Set( SMA( Volume, volumeEmaAve)[0] );
			VolSD = StdDev(Vrg, volumeEmaAve)[0];
			Vp3.Set( Vrg[0] + 3.0 * VolSD );
			Vp2.Set( Vrg[0] + 2.0 * VolSD );
			Vp1.Set( Vrg[0] + 1.0 * VolSD );
			Vn1.Set( Vrg[0] - 1.0 * VolSD );
			Vn2.Set( Vrg[0] - 2.0 * VolSD );
			Vn3.Set( Vrg[0] - 3.0 * VolSD );
			
			Vl.Set(Volume[0] < Volume[1] && Volume[0] < Volume[2] ? true : false); 
			Vh.Set(Volume[0] > Volume[1] && Volume[1] > Volume[2] ? true : false); 
			Vb.Set(Volume[0] > Vrg[0] || Volume[0] > Volume[1] ? true : false); 
			
//			Calculate Range information
			arg.Set( Wilder(spread, volumeEmaAve )[0] );
			wrb.Set( spread[0] >(wbf*arg[0]) ? true : false); 
			nrb.Set( spread[0] <(nbf*arg[0]) ? true : false); 
			
//			Price information
			upbar.Set(Close[0] > Close[1] ? true : false); 	
			dnbar.Set(Close[0] < Close[1] ? true : false); 
			Cloc=Close[0]-Low[0];
			x=spread[0]/Cloc;
			x1 =( Close[0] - Low[0] == 0.00 ? arg[0] : x );
			
//			Trend Definitions
			ucls.Set( x1 < 2 ? true : false); 
			dcls.Set( x1 > 2 ? true : false); 
			mcls.Set( x1 < 2.2 && x1 > 1.8 ? true : false); 
			Vlcls.Set( x1 > 4 ? true : false); 
			Vhcls.Set( x1 < 1.35 ? true : false); 
			j.Set( SMA(Close, 5)[0] );
			TLL= LinRegSlopeSFX( j, false, 40, 0)[0];
			TLM= LinRegSlopeSFX( j, false, 15, 0)[0] ;
			TLS= LinRegSlopeSFX( j, false, 5, 0)[0];
			mp=(High[0]+Low[0])/2;
			

//			VSA Definitions
			utbar.Set(wrb[0] && dcls[0] && TLS > 0 ? true : false); 
			utcond1.Set(utbar[1] && dnbar[0] ? true : false); 	
			utcond2.Set(utbar[1] && dnbar[0] && Volume[0] > Volume[1] ? true : false); 
			utcond3.Set(utbar[0] && Volume[0] > 2*Vrg[0] ? true : false); 	
			trbar.Set(Volume[1] > Vrg[0] && upbar[0] && wrb[1] && dnbar[0] && dcls[0] && wrb[0] && TLL > 0 && High[0]==MAX(High,10)[0] ? true : false); 	
			Hutbar.Set(upbar[1] && (Volume[0] > dwAboveAvgVol*Vrg[0]) && dnbar[0] && dcls[0] && !wrb[0] && !utbar[0] ? true : false); 	
			Hutcond.Set(Hutbar[1] && dnbar[0] && dcls[0] && !utbar[0] ? true : false); 	
			tcbar.Set(upbar[1] && High[0] == MAX(High,5)[0] && dnbar[0] && (dcls[0] || mcls[0]) && Volume[0] > Vrg[0] && !wrb[0] && !Hutbar[0]  ? true : false); 	
			Scond1.Set(utcond1[0] || utcond2[0] || utcond3[0] ? true : false); 	
			Scond2.Set(!Scond1[1] ? true : false); 	
			scond.Set(Scond1[0] && Scond2[0] ? true : false); 
			stdn0.Set(TLL > 0 && Volume[0] > Volume[1] && dnbar[1] && upbar[1] && (ucls[0] || mcls[0]) && TLS < 0 && TLM < 0 ? true : false); 
			stdn.Set(Volume[0] > Volume[1] && dnbar[1] && upbar[0] && (ucls[0] || mcls[0]) && TLS<0 && TLM<0 ? true : false); 
			stdn1.Set(TLL < 0 && Volume[0] > (Vrg[0]*dwAboveAvgVol) && dnbar[1] && upbar[0] && (ucls[0] || mcls[0])&& TLS<0 && TLM<0 ? true : false); 
			stdn2.Set(TLS < 0 && Volume[1] < Vrg[0]  && upbar[0] && Vhcls[0] && Volume[0] > Vrg[0] ? true : false); 
			bycond1.Set(stdn[0] || stdn1[0] ? true : false);
			bycond.Set(upbar[0]  && bycond1[1] ? true : false);
			stvol.Set(Low[0] == MIN(Low,5)[0]  && (ucls[0] || mcls[0]) && Volume[0] >dwAboveAvgVol*Vrg[0] && TLL<0 ? true : false);
			ndbar.Set(upbar[0] && nrb[0] && Vl[0]  && dcls[0] ? true : false);
			nsbar.Set(dnbar[0] && nrb[0] && Vl[0]  && dcls[0] ? true : false);
			nbbar.Set(Close[0] > Close[1] && Volume[0] < Volume[1] && nrb[0] && x1 < 2 ? true : false);
			nbbar1.Set(Close[0] > Close[1] && Volume[0] < Volume[1] &&  Volume[0] < Volume[2] && x1 < 1.1 ? true : false);
			lvtbar.Set(Vl[0] && Low[0]<Low[1] && ucls[0] ? true : false);
			lvtbar1.Set(Volume[0] < Vrg[0] && Low[0]<Low[1] && ucls[0] && TLL>0 && TLM>0 && wrb[0] ? true : false);
			lvtbar2.Set(lvtbar[1] && upbar[0] && ucls[0] ? true : false);
			dbar.Set(Volume[0] > dwUltraHighVol*Vrg[0] && dcls[0] && upbar[0] && TLS>0 && TLM > 0 && !Scond1[0] && !utbar[0] ? true : false);
			eftup.Set(High[0] > High[1] && Low[0]>Low[1] && Close[0] > Close[1] && Close[0]>=((High[0]-Low[0])*dwHighClose+Low[0]) && spread[0]>arg[0] && Volume[0]>Volume[1] ? true : false);
			eftupfl.Set(eftup[1] && (utbar[0] || utcond1[0] || utcond2[0] || utcond3[0]) ? true : false);
			eftdn.Set(High[0] < High[1] && Low[0] < Low[1] && Close[0] < Close[1] &&  Close[0]<=((High[0]-Low[0])*dwLowClose+Low[0]) && spread[0]>arg[0] && Volume[0]>Volume[1] ? true : false);
			
		#region Candle Definition                    
        
           if(TLS>0 && TLM>0 && TLL>0)
				{
					BarColor = Color.Green;
				}
			else if(TLS>0 && TLM>0 && TLL<0)
				{
					BarColor = Color.DarkGreen;
				}
			else if(TLS>0 && TLM<0 && TLL<0)
				{
					BarColor = Color.LimeGreen;
				}
			else if(TLS<0 && TLM<0 && TLL<0)
				{
					BarColor = Color.Red;
				}
			else if(TLS<0 && TLM>0 && TLL>0)
				{
					BarColor = Color.LimeGreen;
				}
				
			else if(TLS<0 && TLM<0 && TLL>0)
				{
					BarColor = Color.Purple;
				}	
				
			else 
				{
					BarColor = Color.Brown;
				}
#endregion			
				
		#region Volume Bar Definition				

				if(utcond3[0])
					Weak.Set(Volume[0]);
				else if(utcond2[0])
					Weak.Set(Volume[0]);
				else if(utbar[0])
					Weak.Set(Volume[0]);
				else if(stdn[0])
					Strong.Set(Volume[0]);
				else if(stdn0[0])
					Strong.Set(Volume[0]);
				else if(stdn1[0])
					Strong.Set(Volume[0]);
				else if(stdn2[0])
					Strong.Set(Volume[0]);
				else
					StrongWeak.Set(Volume[0]);
#endregion				
						
		#region Title Banners			
			
		if (utbar[0] )
		{
			titlestring=" An Upthrust Bar. A sign of weakness. ";
			
			textColor = Color.Yellow;
			bannerColor = Color.Red;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, Color.Black, Color.Yellow);
		}

		if (utcond1[0])
		{
			titlestring=" A downbar after an Upthrust. Confirm weakness. ";
			
			textColor = Color.White;
			bannerColor =Color.Lime;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High,titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}
		if (utcond2[0] && !utcond1[0])
		{
			titlestring=" A High Volume downbar after an Upthrust. Confirm weakness.";
			
			textColor = Color.White;
			bannerColor =Color.Lime;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}
		
		if (utcond3[0])
		{
			titlestring="This upthrust at very High Voume, Confirms weakness";
			
			textColor = Color.Yellow;
			bannerColor =Color.Blue;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, Color.Black, Color.Yellow);		
		}		
		
		if (stdn1[0])
		{
			titlestring="Strength seen returning after a down trend. High volume adds to strength. ";
			
			textColor = Color.Black;
			bannerColor =Color.Yellow;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High,titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}
		
		if (stdn0[0] && !stdn[0])
		{
			titlestring="Strength seen returning after a down trend. ";
			
			textColor = Color.Red;
			bannerColor =Color.Lime;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor , Color.Yellow);		
		}
		
		if (stdn[0] && !stdn1[0])
		{
			titlestring="Strength seen returning after a long down trend. ";
			
			textColor = Color.Red;
			bannerColor =Color.Lime;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor , Color.Yellow);		
		}
		
		if (lvtbar[0])
		{
			titlestring="Test for supply. ";
			
			textColor = Color.Blue;
			bannerColor =Color.Aqua;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}
		
		if (lvtbar2[0])
		{
			titlestring="An Upbar closing near High after a Test confirms strength. ";
			
			textColor = Color.Blue;
			bannerColor =Color.Aqua;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}

		if (bycond[0])
		{
			titlestring="An Upbar closing near High. Confirms return of Strength. ";
			
			textColor = Color.Blue;
			bannerColor =Color.Lime;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}
		
		if (dbar[0])
		{
			titlestring="A High Volume Up Bar closing down in a uptrend shows Distribution. ";
			
			textColor = Color.Blue;
			bannerColor =Color.Yellow;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}

		if (Hutbar[0])
		{
			titlestring="Psuedo UpThrust.   A Sign of Weakness. ";
			
			textColor = Color.White;
			bannerColor =Color.Lime;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}
		if (Hutcond[0])
		{
			titlestring="A Down Bar closing down after a Pseudo Upthrust confirms weakness. ";
			
			textColor = Color.Yellow;
			bannerColor =Color.Blue;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}
		if (lvtbar1[0])
		{
			titlestring="Test for supply in a uptrend. Sign of Strength. ";
			
			textColor = Color.Yellow;
			bannerColor =Color.Blue;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10,bannerColor, Color.Yellow);		
		}
		
		if (stdn2[0])
		{
			titlestring="High volume upbar closing on the high indicates strength. ";
			
			textColor = Color.Black;
			bannerColor =Color.Yellow;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High,titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}
		
		if (tcbar[0])
		{
			titlestring="High volume Downbar after an upmove on high volume indicates weakness. ";
			
			textColor = Color.Yellow;
			bannerColor =Color.Blue;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}
		if (ndbar[0])
		{
			titlestring="No Demand. A sign of Weakness. ";
			
			textColor = Color.White;
			bannerColor =Color.Yellow;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}	
		
		if (nsbar[0])
		{
			titlestring="No Supply. A sign of Strength. ";
			
			textColor = Color.White;
			bannerColor =Color.Lime;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}

		if (eftup[0])
		{
			titlestring="Effort to Rise. Bullish sign ";
			
			textColor = Color.Blue;
			bannerColor =Color.Aquamarine;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}
		if (eftdn[0])
		{
			titlestring="Effort to Fall. Bearish sign ";
			
			textColor = Color.Red;
			bannerColor =Color.Blue;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}
		
		if (eftupfl[0])
		{
			titlestring="Effort to Move up has failed. Bearish sign ";
			
			textColor = Color.Red;
			bannerColor =Color.Blue;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}

		if (stvol[0])
		{
			titlestring="Stopping volume. Normally indicates end of bearishness is nearing. ";
			
			textColor = Color.Blue;
			bannerColor =Color.Turquoise;
			
			if (alertss) 
				Alert("myAlert"+CurrentBar, NinjaTrader.Cbi.Priority.High, titlestring, "Alert1.wav", 10, bannerColor, Color.Yellow);		
		}

		
		if (banners)
				DrawTextFixed("Banner1", titlestring, TextPosition.TopLeft, Color.Black, font, Color.Transparent, Color.Transparent, 1);
		else
				RemoveDrawObject("Banner1");

		
#endregion
		
		#region Message Banners			
			
		if (utbar[0] )
		{
			bannerstring = "Up-thrusts are designed to catch stops and "+"\n"+
			"to mislead as many traders as possible.They are normally "+"\n"+
			"seen after there has been weakness in the background. The market"+"\n"+
			"makers know that the market is weak, so the price is marked up to "+"\n"+
			"catch stops, encourage traders to go long in a weak market,AND panic"+"\n"+
			"traders that are already Short into covering their very good position.";
			
			textColor = Color.Yellow;
			bannerColor = Color.Red;
		}
		if (utcond3[0])
		{
			bannerstring = "This upthrust bar is at high volume."+"\n"+
			"This is a sure sign of weakness. One may even seriously"+"\n"+
			"consider ending the Longs AND be ready to reverse";
			
			textColor = Color.Yellow;
			bannerColor =Color.Blue;
		}
		if (utbar[0] || utcond3[0])
		{
			bannerstring = "Also note that A wide spread down-bar"+"\n"+
			"that appears immediately after any up-thrust, tends to "+"\n"+
			"confirm the weakness (the market makers are locking in traders"+"\n"+
			"into poor positions). With the appearance of an upthrust you "+"\n"+
			"should certainly be paying attention to your trade AND your stops."+"\n"+
			"On many upthrusts you will find that the market will 'test' "+"\n"+
			"almost immediately.";
			
			textColor = Color.Yellow;
			bannerColor =Color.Red;
		}
		if (utcond1[0])
		{
			bannerstring = "A wide spread down bar following a Upthrust Bar."+"\n"+
			"This confirms weakness. The Smart Money is locking in Traders "+"\n"+
			"into poor positions";
			
			textColor = Color.White;
			bannerColor =Color.Lime;
		}
		if (utcond2[0])
		{
			bannerstring = "Also here the volume is high(Above Average)."+"\n"+
			"This is a sure sign of weakness. The Smart Money is locking in"+"\n"+
			"Traders into poor positions";
			
			textColor = Color.White;
			bannerColor =Color.Lime;
		}
		if (stdn[0])
		{
			bannerstring = "Strength Bar. The stock has been in a down Trend."+"\n"+
			"An upbar with higher Volume closing near the High is a sign of "+"\n"+
			"strength returning. The downtrend is likely to reverse soon.";
			
			textColor = Color.Red;
			bannerColor =Color.Lime;
		}
		if (stdn1[0])
		{
			bannerstring = "Here the volume is very much above average."+"\n"+
			"This makes this indication more stronger.";
			
			textColor = Color.Black;
			bannerColor =Color.Yellow;
		}
		if (bycond[0])
		{
			bannerstring = "The previous bar saw strength coming back. "+"\n"+
			"This upbar confirms strength.";
			
			textColor = Color.Blue;
			bannerColor =Color.Lime;
		}
		if (Hutbar[0])
		{
			bannerstring = "A pseudo Upthrust. This normally appears after an"+"\n"+
			"Up Bar with above average volume. This looks like an upthrust bar "+"\n"+
			"closing down near the Low. But the Volume is normally Lower than average."+"\n"+
			"this is a sign of weakness.If the Volume is High then weakness increases."+"\n"+
			"Smart Money is trying to trap the retailers into bad position.";
			
			textColor = Color.White;
			bannerColor =Color.Lime;
		}
		if (Hutcond[0])
		{
			bannerstring = "A downbar after a pseudo Upthrust Confirms weakness. "+"\n"+
			"If the volume is above average the weakness is increased.";
			
			textColor = Color.Yellow;
			bannerColor =Color.Blue;
		}
		if (lvtbar1[0])
		{
			bannerstring = "The previous bar was a successful Test of supply."+"\n"+
			"The current bar is a upbar with higher volume. This confirms strength";
			
			textColor = Color.Yellow;
			bannerColor =Color.Blue;
		}
		if (dbar[0])
		{
			bannerstring = "A wide range, high volume bar in a up trend "+"\n"+
			"closing down is an indication the Distribution is in progress. "+"\n"+
			"The smart money is Selling the stock to the late Comers rushing to "+"\n"+
			"Buy the stock NOT to be Left Out Of a Bullish move.";
			
			textColor = Color.Blue;
			bannerColor =Color.Yellow;
		}
		if (lvtbar2[0])
		{
			bannerstring = "The previous bar was a successful Test of"+"\n"+
			"supply. The current bar is a upbar with higher volume. This "+"\n"+
			"confirms strength";
			
			textColor = Color.Blue;
			bannerColor =Color.Aqua;
		}
		if (tcbar[0])
		{
			bannerstring = "The stock has been moving up on high volume."+"\n"+
			"The current bar is a Downbar with high volume. Indicates weakness"+"\n"+
			"and probably end of the up move";
			
			textColor = Color.Yellow;
			bannerColor =Color.Blue;
		}
		if (eftup[0])
		{
			bannerstring = "Effort to Rise bar. This normally "+"\n"+
			"found in the beginning of a Markup Phase and is bullish"+"\n"+ 
			"sign.These may be found at the top of an Upmove as the "+"\n"+
			"Smart money makes a last effort to move the price to the maximum";
			
			textColor = Color.Blue;
			bannerColor =Color.Aquamarine;
		}
		if (eftdn[0])
		{
			bannerstring = "Effort to Fall bar. This normally"+"\n"+
			"found in the beginning of a Markdown phase.";
			
			textColor = Color.Red;
			bannerColor =Color.Blue;
		}
		if (nsbar[0])
		{
			bannerstring = "No Supply. A no supply bar indicates"+"\n"+
			"supply has been removed and the Smart money can markup the"+"\n"+ 
			"price. It is better to wait for confirmation";
			
			textColor = Color.White;
			bannerColor =Color.Lime;
		}

		if (stvol[0])
		{
			bannerstring = "Stopping Volume. This will be "+"\n"+
			"an downbar during a bearish period closing towards"+"\n"+
			"the Top accompanied by High volume. A stopping Volume "+"\n"+
			"normally indicates that smart money is absorbing the "+"\n"+
			"supply which is a Indication that they are Bullishon "+"\n"+
			"the MArket.Hence we Can expect a reversal in the down trend.";
			
			textColor = Color.Blue;
			bannerColor =Color.Turquoise;
		}

		if (ndbar[0])
		{
			bannerstring ="No Demand Brief Description: "+"\n"+
			"Any up bar which closes in the middle OR Low,"+"\n"+
			"especially if the Volume has fallen off, is a "+"\n"+
			"potential sign of weakness. Things to Look Out for: "+"\n"+
			"if the market is still strong, you will normally see "+"\n"+
			"signs of strength in the next few bars, which will most "+"\n"+
			"probably show itself as a: Down bar with a narrow spread,"+"\n"+
			" closing in the middle OR High. * Down bar on Low Volume.";
			
			textColor = Color.White;
			bannerColor =Color.Yellow;
		}	
		
		if (banners)
				DrawTextFixed("Banner2", bannerstring, TextPosition.BottomLeft,Color.Black, font, Color.Transparent, Color.Transparent, 1);
		else
				RemoveDrawObject("Banner2");
		
#endregion
		
		#region Trend Text Definition				
		
		string textMsg1 = "Vol:";
			if( Volume[0] > Vp2[0] )
				textMsg1 = textMsg1 + " Very High";
			else if( Volume[0] > Vp1[0] )
				textMsg1 = textMsg1 + " High";
			else if( Volume[0] > Vrg[0] )
				textMsg1 = textMsg1 + " Above Average";
			else if( Volume[0] < Vrg[0] && Volume[0] > Vn1[0] )
				textMsg1 = textMsg1 + " Less Than Average";
			else if( Volume[0] < Vn1[0] )
				textMsg1 = textMsg1 + " Low";
			else textMsg1 = textMsg1 + " ";
		
		
		textMsg1 = textMsg1 + "\nSpread:";
			if( Range()[0] > (arg[0] * 2.0) )
				textMsg1 = textMsg1 + " Wide";
			else if( Range()[0] > arg[0] )
				textMsg1 = textMsg1 + " Above Average";
			else
				textMsg1 = textMsg1 + " Narrow";
		
			
		textMsg1 = textMsg1 + "\nClose:";
			if( Vhcls[0] )
				textMsg1 = textMsg1 + " Very High";
			else if( ucls[0] )
				textMsg1 = textMsg1 + " High";
			else if( mcls[0] )
				textMsg1 = textMsg1 + " Mid";
			else if( dcls[0] )
				textMsg1 = textMsg1 + " Down";
			else 
				textMsg1 = textMsg1 + "Very Low";
		
		string textMsg2 = "Trend:";
			if(TLS > 0 )
				textMsg2 = textMsg2 + "  Shrt Trm-Up";
			else
				textMsg2 = textMsg2 + "  Shrt Trm-Down";
		
		if( TLM > 0 ) 
				textMsg2 = textMsg2 + "\nMid Trm-Up";
			else
				textMsg2 = textMsg2 + "\nMid Trm-Down";	
			if( TLL > 0 ) 
				textMsg2 = textMsg2 + "  Lng Trm-Up";
			else
				textMsg2 = textMsg2 + "  Lng Trm-Down";
			DrawTextFixed( "Msg2", textMsg1 + "\n" + textMsg2, TextPosition.TopRight,Color.Black, font, Color.Transparent, Color.Transparent, 1);
#endregion			

		#region Shapes			
			
		if (utbar[0] && !scond[0])
		{
			DrawSquare("MySquare"+CurrentBar, 0, High[0] + 2 * TickSize, Color.Red);
		}
		if (trbar[0])
		{
			//Change Small Circle from original code to Diamond
			DrawDiamond("MyDiamond"+CurrentBar, 0, High[0] + 2 * TickSize, Color.Blue);
		}
		if (scond[0])
		{
			DrawTriangleDown("MyTriangleDown"+CurrentBar, 0, High[0] + 2 * TickSize, Color.Red);
		}
		if (stdn[0])
		{
			DrawSquare("MySquare"+CurrentBar, 0, Low[0] - 2 * TickSize, Color.Lime);
		}
		if (stdn1[0])
		{
			DrawSquare("MySquare"+CurrentBar, 0, Low[0] - 2 * TickSize, Color.Lime);
		}
		if (lvtbar1[0])
		{
			DrawSquare("MySquare"+CurrentBar, 0, Low[0] - 2 * TickSize, Color.Lime );
		}
		if (lvtbar2[0])
		{
			DrawTriangleUp("MyTriangleUp"+CurrentBar, 0, Low[0] - 2 * TickSize, Color.Yellow);
		}
		if (stvol[0])
		{
			//Change Small Circle from original code to Diamond
			DrawDiamond("MyDiamond"+CurrentBar, 0, Low[0] - 2 * TickSize, Color.Lime);
		}
		if (bycond[0])
		{
			DrawTriangleUp("MyTriangleUp"+CurrentBar, 0, Low[0] - 2 * TickSize, Color.Lime);
		}
		if (Hutbar[0])
		{
			DrawSquare("MySquare"+CurrentBar, 0, High[0] + 2 * TickSize, Color.Blue);
		}
		if (Hutcond[0])
		{
			DrawTriangleDown("MyTriangleDown"+CurrentBar, 0, High[0] + 2 * TickSize, Color.Blue);
		}
		if (tcbar[0])
		{
			DrawTriangleDown("MyTriangleDown"+CurrentBar, 0, High[0] + 2 * TickSize, Color.Yellow);
		}
		if (stdn2[0])
		{
			DrawTriangleUp("MyTriangleUp"+CurrentBar, 0, Low[0] - 2 * TickSize, Color.Aqua);
		}
		if (dbar[0])
		{
			DrawSquare("MySquare"+CurrentBar, 0, High[0] + 2 * TickSize,Color.Blue);
		}
		if (lvtbar[0])
		{
			DrawSquare("MySquare"+CurrentBar, 0, Low[0] - 2 * TickSize, Color.DeepPink);
		}
		if (ndbar[0])
		{
			DrawSquare("MySquare"+CurrentBar, 0, High[0] + 2 * TickSize, Color.Blue);
		}
		if (nsbar[0])
		{
			DrawDiamond("MyDiamond"+CurrentBar, 0, Low[0] - 2 * TickSize, Color.Lime);
		}

		if (eftup[0])
		{
			DrawDiamond("MyDiamond"+CurrentBar, 0, Median[0] , Color.Turquoise);
		}

		if (eftdn[0])
		{
			DrawDiamond("MyDiamond"+CurrentBar, 0, Median[0],Color.Yellow);
		}	

		
#endregion		
        }

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries VolumeEma
        {
            get { return Values[0]; }
        }
		
	
		[Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Strong
        {
            get { return Values[1]; }
        }

		
		[Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Weak
        {
            get { return Values[2]; }
        }

		[Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries StrongWeak
        {
            get { return Values[3]; }
        }
		

        [Description("Periods Volume EMA Average")]
        [Category("Parameters")]
		[Gui.Design.DisplayNameAttribute("Periods Volume Average")]
        public int VolumeEmaAve
        {
            get { return volumeEmaAve; }
            set { volumeEmaAve = Math.Max(1, value); }
        }
		
		[Description("Wide Spread Factor")]
        [Category("Spread Parameters")]
		[Gui.Design.DisplayNameAttribute("Wide Spread Factor")]
        public double DwWideSpread
        {
            get { return wbf;  }
            set { wbf = Math.Max(1, value); }
        }
		
		[Description("Narrow Spread Factor")]
        [Category("Spread Parameters")]
		[Gui.Design.DisplayNameAttribute("Narrow Spread Factor")]
        public double DwNarrowSpread 
        {
            get { return nbf; }
            set { nbf = Math.Max(1, value); }
        }
//		[Description("Spread Middle Factor")]
//        [Category("Spread Parameters")]
//		[Gui.Design.DisplayNameAttribute("Spread Middle Factor")]
//        public double DwSpreadMiddle 
//        {
//            get { return dwSpreadMiddle; }
//            set { dwSpreadMiddle = Math.Max(1, value); }
//        }
		
		[Description("High Close Factor")]
        [Category("Price Parameters")]
		[Gui.Design.DisplayNameAttribute("High Close Factor")]
        public double DwHighClose 
        {
            get { return dwHighClose; }
            set { dwHighClose = Math.Max(1, value); }
        }
		
		[Description("Low Close Factor")]
        [Category("Price Parameters")]
		[Gui.Design.DisplayNameAttribute("Low Close Factor")]
        public double DwLowClose 
        {
            get { return dwLowClose; }
            set { dwLowClose = Math.Max(1, value); }
        }
		
		[Description("Ultra HighVol Factor")]
        [Category("Volume Parameters")]
		[Gui.Design.DisplayNameAttribute("Ultra HighVol Factor")]
        public double DwUltraHighVol 
        {
            get { return dwUltraHighVol; }
            set { dwUltraHighVol = Math.Max(1, value); }
        }
//		
//		[Description("Very HighVol Factor")]
//        [Category("Volume Parameters")]
//		[Gui.Design.DisplayNameAttribute("Very HighVol Factor")]
//        public double DwVeryHighVol 
//        {
//            get { return dwVeryHighVol; }
//            set { dwVeryHighVol = Math.Max(1, value); }
//        }
		
//		[Description("HighVol Factor")]
//        [Category("Volume Parameters")]
//		[Gui.Design.DisplayNameAttribute("High Vol Factor")]
//        public double DwHighVol 
//        {
//            get { return dwHighVol; }
//            set { dwHighVol = Math.Max(1, value); }
//        }
		[Description("Above AvgVol Factor")]
        [Category("Volume Parameters")]
		[Gui.Design.DisplayNameAttribute("Above AvgVol Factor")]
        public double  DwAboveAvgVol 
        {
            get { return  dwAboveAvgVol; }
            set { dwAboveAvgVol = Math.Max(1, value); }
        }
//
//		[Description("Low Vol Factor")]
//        [Category("Volume Parameters")]
//		[Gui.Design.DisplayNameAttribute("Low Volume Factor")]
//        public double  DwLowVol  
//        {
//            get { return  dwLowVol ; }
//            set {dwLowVol = Math.Max(1, value); }
//        }
		
		[Description("Show Banners")]
        [Category("Visual Aids")]
		[Gui.Design.DisplayNameAttribute("Show Banners ?")]
        public bool  Banners  
        {
            get { return banners; }
            set { banners = value; }
        }

		[Description("Show Alerts")]
        [Category("Visual Aids")]
		[Gui.Design.DisplayNameAttribute("Show Alerts ?")]
        public bool  Alertss  
        {
            get { return alertss; }
            set { alertss = value; }
        }
		
		[XmlIgnore()]
		[Description("Band Color")]
		[Category("Visual")]
		[Gui.Design.DisplayNameAttribute("Band Color")]
		public Color BandAreaColor
		{
			get { return bandAreaColor; }
			set { bandAreaColor = value; }
		}

		/// <summary>
		/// </summary>
		[Browsable(false)]
		public string BandAreaColorSerialize
		{
			get { return NinjaTrader.Gui.Design.SerializableColor.ToString(bandAreaColor); }
			set { bandAreaColor = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
		}
		
		[XmlIgnore()]
		[Description("Band Color Opacity")]
		[Category("Visual")]
		[Gui.Design.DisplayNameAttribute("Band Color Opacity")]
		public int BandAreaColorOpacity
		{
			get { return bandAreaColorOpacity; }
			set { bandAreaColorOpacity = Math.Max(value, 1); }
		}
		
		
		[XmlIgnore()]
		[Description("Font")]
		[Category("Visual")]
		[Gui.Design.DisplayNameAttribute("Banner Font")]
			public Font Font
			
			{
				get { return font; }
				set { font = value; }
			}
			
			[Browsable(false)]
			public SerializableFont FontSerializable
			
			{
			get { return SerializableFont.FromFont(font); }
			set { font = SerializableFont.ToFont(value); }
			}
		
        #endregion
		
		#region PlotRegion					
				public override void Plot(Graphics graphics, Rectangle bounds, double min, double max)
		{
			
			base.Plot(graphics, bounds, min, max);

			if (Bars == null || ChartControl == null)
				return;
				
			SolidBrush brush = new SolidBrush(Color.FromArgb(bandAreaColorOpacity*20,bandAreaColor));
			int	barWidth = ChartControl.ChartStyle.GetBarPaintWidth(ChartControl.BarWidth);
			SmoothingMode oldSmoothingMode = graphics.SmoothingMode;
			GraphicsPath path = new GraphicsPath();

			for ( int seriesCount =0; seriesCount < 2; seriesCount++)
			{
				int	lastX = -1;
				int	lastY = -1;
				DataSeries	series = (DataSeries) Values[seriesCount];
				double val = 0;
				Gui.Chart.Plot plot = Plots[seriesCount];

				for (int count = 0; count < ChartControl.BarsPainted; count++)
				{
					int idx = ChartControl.LastBarPainted - ChartControl.BarsPainted + 1 + count;
					if (idx < 0 || idx >= Input.Count || (!ChartControl.ShowBarsRequired && idx < BarsRequired))
						continue;

					if (seriesCount == 0) val	= series.Get(idx); else val = 0;
//					if (val == 0)						continue;

					int			x	= (int) (ChartControl.CanvasRight - ChartControl.BarMarginRight - barWidth / 2
						- (ChartControl.BarsPainted - 1) * ChartControl.BarSpace + count * ChartControl.BarSpace) + 1;
					int			y	= (int) ((bounds.Y + bounds.Height) - ((val - min ) / Gui.Chart.ChartControl.MaxMinusMin(max, min)) * bounds.Height);

					if (lastX >= 0) 
					{
						path.AddLine(lastX - plot.Pen.Width / 2, lastY, x - plot.Pen.Width / 2, y);
						
					}

					lastX	= x;
					lastY	= y;
				}
				path.Reverse();
				
			}
			graphics.SmoothingMode = SmoothingMode.AntiAlias;
			graphics.FillPath(brush, path);
			graphics.SmoothingMode = oldSmoothingMode;
		}
#endregion
		
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private VPA1[] cacheVPA1 = null;

        private static VPA1 checkVPA1 = new VPA1();

        /// <summary>
        /// Volume Spread Analysis
        /// </summary>
        /// <returns></returns>
        public VPA1 VPA1(int volumeEmaAve)
        {
            return VPA1(Input, volumeEmaAve);
        }

        /// <summary>
        /// Volume Spread Analysis
        /// </summary>
        /// <returns></returns>
        public VPA1 VPA1(Data.IDataSeries input, int volumeEmaAve)
        {
            checkVPA1.VolumeEmaAve = volumeEmaAve;
            volumeEmaAve = checkVPA1.VolumeEmaAve;

            if (cacheVPA1 != null)
                for (int idx = 0; idx < cacheVPA1.Length; idx++)
                    if (cacheVPA1[idx].VolumeEmaAve == volumeEmaAve && cacheVPA1[idx].EqualsInput(input))
                        return cacheVPA1[idx];

            VPA1 indicator = new VPA1();
            indicator.BarsRequired = BarsRequired;
            indicator.CalculateOnBarClose = CalculateOnBarClose;
            indicator.Input = input;
            indicator.VolumeEmaAve = volumeEmaAve;
            indicator.SetUp();

            VPA1[] tmp = new VPA1[cacheVPA1 == null ? 1 : cacheVPA1.Length + 1];
            if (cacheVPA1 != null)
                cacheVPA1.CopyTo(tmp, 0);
            tmp[tmp.Length - 1] = indicator;
            cacheVPA1 = tmp;
            Indicators.Add(indicator);

            return indicator;
        }

    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Volume Spread Analysis
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.VPA1 VPA1(int volumeEmaAve)
        {
            return _indicator.VPA1(Input, volumeEmaAve);
        }

        /// <summary>
        /// Volume Spread Analysis
        /// </summary>
        /// <returns></returns>
        public Indicator.VPA1 VPA1(Data.IDataSeries input, int volumeEmaAve)
        {
            return _indicator.VPA1(input, volumeEmaAve);
        }

    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Volume Spread Analysis
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.VPA1 VPA1(int volumeEmaAve)
        {
            return _indicator.VPA1(Input, volumeEmaAve);
        }

        /// <summary>
        /// Volume Spread Analysis
        /// </summary>
        /// <returns></returns>
        public Indicator.VPA1 VPA1(Data.IDataSeries input, int volumeEmaAve)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.VPA1(input, volumeEmaAve);
        }

    }
}
#endregion
